#ifndef __UPGRADE_H_
#define __UPGRADE_H_
#include "flashdrv.h"


#define BIT_PCBA        0x0100
#define BIT_PROD_ID     0x0200
#define BIT_PROT_ID     0x0400
#define BIT_FUNC_ID     0x0800

#define VER_BUF_LEN       9   

#define REGION_CHK_FAIL -5
#define VERSION_CHK_FAIL -6

struct pid_s {
	signed short version_control;   
	signed short upgrade_control;
	unsigned char  hw_id[32];
	signed short hw_version;
	unsigned long product_id;
	signed short protocol_id;
	signed char  function_id[6];
	signed short fw_version;
	signed short start_code_seg;
	signed short code_size;
	signed char  signature[7];
	signed short control_no;
	signed short download_flag;	
}__attribute__ ((packed)) ;

struct pid_no_protect{
    unsigned short product_id;
    unsigned short protocol_id;
    unsigned short fw_version;
} __attribute__ ((packed));


struct HWID {
//#ifdef _BIG_ENDIAN_
  /*----- Interface --------------------------*/
  unsigned char  fPrn      :2;  /* Printer */
  unsigned char  fMIO      :1;  /* MIO */
  unsigned char  fChinese  :1;  /* Chinese */
  unsigned char  fSCSI     :2;  /* SCSI */
  unsigned char  fPrnIn    :2;  /* Printer port in */

  unsigned char  fNetworkNo:4;  /* Number of network */
  unsigned char  fSerialNo :4;  /* Number of serial port */

  /*----- System -----------------------------*/
  unsigned char  fRomType  :1;  /* 0= Fladsh, 1= OTROM */
  unsigned char  fRAM      :3;  /* 000= 32K, 001= 128K, 010= 256K, 011= 1024K */
  unsigned char  fNVRAM    :2;  /* 00= 256B, 01= 512B, 10= 8192B */
  unsigned char  fRsv_2    :2;
  unsigned char  fCPU      :3;  /* 000= 188, 001= 186, 010= 386DX */

  unsigned char  fSpeed    :2;  /*      188/186   386DX
                           00   12MHz    16MHz
                           01   16MHz    25MHz
                           10   25MHz    33MHz
                           11   40MHz    40MHz  */
  unsigned char  fRomSize  :3;  /* 000= 64K, 001= 128K, 010= 256K, 011= 512K */

  /*----- Card number ------------------------*/
  unsigned char  bVersion  :4;
  unsigned char  bRsv_1    :4;

  unsigned char  fProduct2 :4;
  unsigned char  fDetail   :4;

  unsigned char  fProduct0 :4;
  unsigned char  fProduct1 :4;
//#else
  /*----- Card number ------------------------*/
//  unsigned char  fProduct1 :4;
//  unsigned char  fProduct0 :4;

//  unsigned char  fDetail   :4;
 // unsigned char  fProduct2 :4;

 // unsigned char  bRsv_1    :4;
 // unsigned char  bVersion  :4;

  /*----- System -----------------------------*/
 // unsigned char  fRomSize  :3;  /* 000= 64K, 001= 128K, 010= 256K, 011= 512K */
 // unsigned char  fSpeed    :2;  
 /*      188/186   386DX
                           00   12MHz    16MHz
                           01   16MHz    25MHz
                           10   25MHz    33MHz
                           11   40MHz    40MHz  */
 // unsigned char  fCPU      :3;  /* 000= 188, 001= 186, 010= 386DX */

 // unsigned char  fRsv_2    :2;
 // unsigned char  fNVRAM    :2;  /* 00= 256B, 01= 512B, 10= 8192B */
 // unsigned char  fRAM      :3;  /* 000= 32K, 001= 128K, 010= 256K, 011= 1024K */
//  unsigned char  fRomType  :1;  /* 0= Fladsh, 1= OTROM */

  /*----- Interface --------------------------*/
 // unsigned char  fSerialNo :4;  /* Number of serial port */
 // unsigned char  fNetworkNo:4;  /* Number of network */

//  unsigned char  fPrnIn    :2;  /* Printer port in */
 // unsigned char  fSCSI     :2;  /* SCSI */
 // unsigned char  fChinese  :1;  /* Chinese */
 // unsigned char  fMIO      :1;  /* MIO */
 // unsigned char  fPrn      :2;  /* Printer */
//#endif

  unsigned short  wRsv_3;

  /*----- description ------------------------*/
  unsigned char  bComment[23];

} __attribute__ ((packed));


struct PID {

  /*----- PID version ------------------------*/
  unsigned short  wPidVersion;        /* Motorola format */

  /*----- D/L control ------------------------*/
  unsigned  char  fReserved;
//#ifdef _BIG_ENDIAN_
  unsigned  char  fRsv        :  4;
  unsigned  char  fChkFunction:  1;
  unsigned  char  fChkProtocol:  1;
  unsigned  char  fChkProduct:   1;
  unsigned  char  fChkHw:        1;
//#else
  //unsigned  char  fChkHw:        1;
  //unsigned  char  fChkProduct:   1;
  //unsigned  char  fChkProtocol:  1;
  //unsigned  char  fChkFunction:  1;
  //unsigned  char  fRsv        :  4;
//#endif
  /*----- Hardware ID ------------------------*/
  struct HWID  hw;

  /*----- Reserver ---------------------------*/
  unsigned short  wRsv;

  /*----- Product ID & mask ------------------*/
  unsigned short  wProductID;         /* Motorola format */
  unsigned short  wProductMask;       /* Motorola format */

  /*----- Protocol ID & mask -----------------*/
  unsigned short  wProtocolID;        /* Motorola format */
  unsigned short  wProtocolMask;      /* Motorola format */

  /*----- Function ID & mask -----------------*/
  unsigned short  wFunctionID;        /* Motorola format */
  unsigned short  wFunctionMask;      /* Motorola format */

  /*----- F/W version ------------------------*/
  unsigned short  wFwVersion;         /* Motorola format */

  /*----- Code address -----------------------*/
  unsigned short  wSegment;           /* Intel format */
  unsigned short  wOffset;            /* Intel format */

} __attribute__ ((packed));

int upgrade_img(uint32 __flash_base);

#define LOCAL_IMG    "/var/img"

#endif
